zflutter 0.0.1+2

  • Readme
  • Changelog
  • Example
  • Installing
  • 76

Zflutter #

A pseudo-3D engine for Flutter.

This is an alpha version and it might change before release.

To read the docs and see examples visit z.flutter.gallery

Zflutter is based on Zdog #

First we would like to give the mertits to Zdog, the pseudo-3D JavaScript engine that has been the base inspiration for this project.

We encourage to take a look to Zdog and enjoy their awesome examples and documentation.

Contribution #

I would love to get the feedback from people on how they would approach it and what they think it could be improved. Feel free to message me on twitter @JamesBlasco or telegram @JamesBlasco

Also I would like to encourage to submit issues and PR to improve this package.

Roadmap #

  • Polish the code and add documentation
  • Add testing
  • Implement hitTest in ZWidgets

[0.0.1] - First Version #

Welcome to ZFlutter

example/lib/main.dart

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import 'examples/examples.dart';
import 'flutter_widget.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      debugShowCheckedModeBanner: false,
      title: 'Flutter Demo',
      theme: ThemeData(
        primaryColor: Colors.grey[200],
        appBarTheme: AppBarTheme(elevation: 0),
        // This is the theme of your application.
        //
        // Try running your application with "flutter run". You'll see the
        // application has a blue toolbar. Then, without quitting the app, try
        // changing the primarySwatch below to Colors.green and then invoke
        // "hot reload" (press "r" in the console where you ran "flutter run",
        // or simply save your changes to "hot reload" in a Flutter IDE).
        // Notice that the counter didn't reset back to zero; the application
        // is not restarted.
        primarySwatch: Colors.blue,
        // This makes the visual density adapt to the platform that you run
        // the app on. For desktop platforms, the controls will be smaller and
        // closer together (more dense) than on mobile platforms.
        visualDensity: VisualDensity.adaptivePlatformDensity,
      ),
      routes: {
        ...[...Examples.list, ...BasicSamples.list].asMap().map(
              (key, example) => MapEntry(
                example.route,
                (context) => Scaffold(
                  backgroundColor: example.backgroundColor,
                  appBar: example.route == '/logo'
                      ? null
                      : AppBar(
                          centerTitle: true,
                          title: Text(example.title),
                        ),
                  body: MadeWithFlutterContainer(
                    child: example.builder(context),
                    logoStyle: example.logoStyle ?? FlutterLogoColor.original,
                  ),
                ),
              ),
            ),
        // Demos for the website
        ...[...Examples.list, ...BasicSamples.list].asMap().map(
              (key, example) => MapEntry(
                  '/demo${example.route}',
                  (context) => Container(
                        color: example.backgroundColor ?? Color(0xffF5F6FA),
                        child: Transform.scale(
                          scale: 0.45,
                          child: example.builder(context),
                        ),
                      )),
            ),
      },
      home: MyHomePage(),
    );
  }
}

class MyHomePage extends StatefulWidget {
  MyHomePage({Key key}) : super(key: key);

  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('Zflutter'),
      ),
      body: GridView.builder(
        itemBuilder: (context, index) {
          final item = examples[index];
          return KeyedSubtree(
            key: Key(item.title),
            child: InkWell(
              onTap: () {
                Navigator.of(context).pushNamed(item.route);
              },
              child: Stack(
                children: [
                  Transform.scale(
                      scale: 0.2,
                      child: TickerMode(
                          enabled: false, child: item.builder(context))),
                  Container(
                    padding: EdgeInsets.all(8),
                    color: Colors.grey[100].withOpacity(0.8),
                    child: Center(
                        child: Text(
                      item.title,
                      textAlign: TextAlign.center,
                      style: Theme.of(context).textTheme.headline6,
                    )),
                  )
                ],
              ),
            ),
          );
        },
        gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
          crossAxisCount: MediaQuery.of(context).size.width ~/ 200,
          childAspectRatio: 1,
        ),
        itemCount: examples.length,
      ),
    );
  }

  List<Example> get examples => [
        ...Examples.list,
        ...BasicSamples.list,
      ];
}

Use this package as a library

1. Depend on it

Add this to your package's pubspec.yaml file:


dependencies:
  zflutter: ^0.0.1+2

2. Install it

You can install packages from the command line:

with Flutter:


$ flutter pub get

Alternatively, your editor might support flutter pub get. Check the docs for your editor to learn more.

3. Import it

Now in your Dart code, you can use:


import 'package:zflutter/zflutter.dart';
  
Popularity:
Describes how popular the package is relative to other packages. [more]
56
Health:
Code health derived from static analysis. [more]
100
Maintenance:
Reflects how tidy and up-to-date the package is. [more]
90
Overall:
Weighted score of the above. [more]
76
Learn more about scoring.

We analyzed this package on Jul 7, 2020, and provided a score, details, and suggestions below. Analysis was completed with status completed using:

  • Dart: 2.8.4
  • pana: 0.13.13
  • Flutter: 1.17.5

Analysis suggestions

Package not compatible with SDK dart

because of import path [zflutter] that is in a package requiring null.

Maintenance suggestions

Package is pre-v0.1 release. (-10 points)

While nothing is inherently wrong with versions of 0.0.*, it might mean that the author is still experimenting with the general direction of the API.

Dependencies

Package Constraint Resolved Available
Direct dependencies
Dart SDK >=2.7.0 <3.0.0
flutter 0.0.0
quiver ^2.1.3 2.1.3
Transitive dependencies
collection 1.14.12 1.14.13
matcher 0.12.8
meta 1.1.8 1.2.1
path 1.7.0
sky_engine 0.0.99
stack_trace 1.9.5
typed_data 1.1.6 1.2.0
vector_math 2.0.8
Dev dependencies
flutter_test